<?php
require_once "datacoord.php";
require_once "test-matrix-invert.php";
ini_set('precision', 36);
const R=6378249.145;
const F= 0.0034075613786993;
const R84= 6378137;
const F84= 0.0033528106647475;
const RHO=206264.8;
const FIAS0=0.168177017834269193485852;
const ELAS0=0.113732441453425300870173;
const HTAS0=279.6;
const FIO84=0.168233435602339886916212;
const ELO84=0.114470807845496819199482;
const HTO84=472.194;
const RAD=0.0174532925199432954743717;
 
	  
	  
$_tx=-91.186;
$_ty=-88.808;
$_tz=118.868;
$_rx=-2.651;
$_ry=0.530;
$_rz=0.749;
$_ds=6.763;
$_x0=6238199.620;
$_y0=806951.445;
$_z0=982203.058;
	
	function x_to_phi($x,$y,$z)
	{
		$r=sqrt(pow($x,2) + pow($y,2));
		$tr =$z/$r;
		$phi0=atan($tr);
		$esq=2 * F -pow(F,2);
		$v=0;
		for($i=1;$i< 5;$i++)
		{
			$sphi=sin($phi0);
			$v=R/sqrt(1-$esq*pow($sphi,2));
			$tphi=($z + $esq*$v*$sphi)/ $r;
			$phi0=atan($tphi);
		}
		$la=atan($y/$x);
		$ht= ($x /(cos($la) * cos($phi0))) -$v;
		return array('phi'=>$phi0,'la'=>$la,'ht'=>$ht);
	
	}
	function x_to_deg_phi($x,$y,$z)
	{
		$p=x_to_phi($x,$y,$z);
		return array('phi'=>$p['phi']/RAD,'la'=>$p['la']/RAD,'ht'=>$p['ht']);
	}
	function phi_to_x($phi,$lamda,$ht)
	{
		$esq=2*F -pow(F,2);
		$v= R/sqrt(1 - $esq * pow(sin($phi),2));
		
		$x=($v + $ht)* cos($phi) * cos($lamda);
		$y=($v + $ht)* cos($phi) * sin($lamda);
		$z=((1- $esq)*$v + $ht)* sin($phi) ;
		
		return array('x'=>$x,'y'=>$y,'z'=>$z);
	
	}
	function deg_phi_to_x($phi,$lamda,$ht)
	{
		$phi=$phi * M_PI /180;
		$lamda=$lamda * M_PI /180;
		return phi_to_x($phi,$lamda,$ht);
	
	}
	
	function phi_to_x84($phi,$lamda,$ht)
	{
		$esq=2*F84 -pow(F84,2);
		$v= R84/sqrt(1 - $esq * pow(sin($phi),2));
		
		$x=($v + $ht)* cos($phi) * cos($lamda);
		$y=($v + $ht)* cos($phi) * sin($lamda);
		$z=((1- $esq)*$v + $ht)* sin($phi) ;
		
		return array('x'=>$x,'y'=>$y,'z'=>$z);
	
	}
	
	function transform($phi,$lamda,$ht,$tx,$ty,$tz,$rx,$ry,$rz,$ds)
	{
		
		$rx=$rx/RHO;$ry=$ry/RHO;$rz=$rz/RHO;
		
		$p0=phi_to_x84(FIO84,ELO84,HTO84);
		$p1=phi_to_x84($phi,$lamda,$ht);
		
		$rm[]=array($ds+1,$rz,-$ry);
		$rm[]=array(-$rz,$ds+1,$rx);
		$rm[]=array($ry,-$rx,$ds+1,);
		$dm=array(0=>array($p1['x']-$p0['x'],$p1['y']-$p0['y'],$p1['z']-$p0['z']));
		
		$rs=multiply_matrix( $dm,$rm);
		$x2=$p0['x'] + $tx + $rs[0][0];
		$y2=$p0['y'] + $ty + $rs[0][1];
		$z2=$p0['z'] + $tz + $rs[0][2];
		
		return x_to_phi($x2,$y2,$z2);
	}
	function seek($x,$y)
	{
		$x0=($x -3.0)/0.5;
		$y0=($y -4.5)/0.5;
		$p[0]=array(floor($x0),floor($y0));
		$p[1]=array(ceil($x0),floor($y0));
		$p[2]=array(ceil($x0),ceil($y0));
		$p[3]=array(floor($x0),ceil($y0));
		return $p;
	}
	
	function IDW($ds,$m,$p)
	{
		$x=$p[0];
		$y=$p[1];
		$sh=0;
		$sx=0;
		$sy=0;
		$sz=0;
		$a=seek($x,$y);
		foreach($a as $k=> $v)
		{
			$vx=$v[0]+1;
			$vy=($v[1])*4;
			$sk=$v[0] * 20 + $v[1];
			$f=str_getcsv ($m[$vx]);
			$dx=($x-$f[$vy+1]) * 60;
			$dy=($y -$f[$vy+2]) * 60;
			$h=1/( pow($dx,2) + pow($dy,2));
			$sh += $h;
			$sx +=$ds[$sk]['x'] * $h;
			$sy +=$ds[$sk]['y'] * $h;
			$sz +=$ds[$sk]['z'] * $h;
		}
		return array('x'=>$sx/$sh,'y'=>$sy/$sh,'z'=>$sz/$sh);
	}
	
	
	$pr1=9.319465467*RAD;
	$pr2=12.22995437*RAD;
	$p4=transform($pr1,$pr2,287.0361,$_tx,$_ty,$_tz,$_rx,$_ry,$_rz,$_ds);
	echo "<br>TRANSFORMED ";print_r($p4);
	
	//echo $p4['phi']/RAD;
	/*
	$p2=deg_phi_to_x(09.319180833,12.23059028,268.127);
	print_r($p2);
	print_r(x_to_deg_phi($p2['x'],$p2['y'],$p2['z']));
	//print_r();
	*/
	echo "---------orginal minna points --------------<br>";
	$n=0;
	$cpt=str_getcsv ($_a1);
	for($i=0; $i < count($cpt); $i+=4)
	{
		//echo 'ppp';
		$p=deg_phi_to_x($cpt[$i+1],$cpt[$i+2],$cpt[$i+3]);
		//print_r($p);
		$opt[$n]['label']=$cpt[$i];
		foreach($p as $k => $v)
		{
			$opt[$n][$k]=$v;
		}
		
		$n++;
	}
	
	echo "---------------------<br>";
	$n=0;
	for($j=1;$j<=count($_c);$j++)
	{
		$cpt=str_getcsv ($_c[$j]);
		for($i=0; $i < count($cpt); $i+=4)
		{
			$p=deg_phi_to_x($cpt[$i+2],$cpt[$i+1],$cpt[$i+3]);
			//print_r($p);
			foreach($p as $k => $v)
			{
				$grd[$n][$k]=$v;
			}
			$n++;
		}
	}
	
	echo "---------TRANSFORMATION OF THE GRID POINTS------------<br>";
	$n=0;
	for($j=1;$j<=count($_b);$j++)
	{
		$cpt=str_getcsv ($_b[$j]);
		for($i=0; $i < count($cpt); $i+=4)
		{
			$p0=transform($cpt[$i+2]*RAD,$cpt[$i+1]*RAD,$cpt[$i+3],$_tx,$_ty,$_tz,$_rx,$_ry,$_ry,$_ds);
			$p=phi_to_x($p0['phi'],$p0['la'],$p0['ht']);
			foreach($p as $k => $v)
			{
				$df[$n][$k]=$grd[$n][$k] -$v;
				$trns[$n][$k]=$v;
			}
			$trns[$n]['label']=$cpt[$i];
			$n++;
		}
	}
		echo "---------TRANSFORMATION OF 35 POINTS ------------<br>";
	$cpt=str_getcsv ($_a2);
	$n=0;
	for($i=0; $i < count($cpt); $i+=5)
	{
		echo "--------- $cpt[$i] -------------<br>";
		$p0=transform($cpt[$i+1]*RAD,$cpt[$i+2]*RAD,$cpt[$i+3],$_tx,$_ty,$_tz,$_rx,$_ry,$_ry,$_ds);
		//echo "<br>Transformed point ";print_r($p0);
		
		$p=phi_to_x($p0['phi'],$p0['la'],$p0['ht']);
		
		//echo "$cpt[$i] ";print_r($p);echo "<br>";
		$cdf[$n]['label']=$cpt[$i];
		foreach($p as $k => $v)
		{
			$trs[$n][$k]=$v;
			$cdf[$n][$k]=$opt[$n][$k]-$v;
		}
		$a=seek($cpt[$i+2],$cpt[$i+1]);
		$nk=0;
		foreach($a as $k=> $v)
		{
			$sk=$v[0] * 20 + $v[1];
			foreach($trs[$n] as $k2 => $v2)
			{
				$drf[$sk][$k2]=$trns[$sk][$k2] - $v2;
			}

		}
		echo  $cpt[$i] .' '.$cpt[$i+1].' /'.$cpt[$i+2]."...<br>";
		echo "transformed - ";print_r($trs[$n]);echo "<br>";
		$cr=IDW($df,$_b,array($cpt[$i+2],$cpt[$i+1]));
		echo "correction - ";print_r($cr);echo "<br>";
		foreach($cr as $k => $v)
		{
			$pcr[$n][$k]=$trs[$n][$k]+ $v;
			$pdf[$n][$k]=$opt[$n][$k]-$pcr[$n][$k];
		}
		echo "corrected - ";print_r($pcr[$n]);echo "<br>";
		echo "new diff - ";print_r($pdf[$n]);echo "<br>";
	
		
		$n++;
	}

	

?>